{% import 'actions.html' as macros %}
<!-- Same use of tabs and styling as in workflow_step_details.html  -->
<!-- Only tabs for missing/existing inputs, no actions              -->

<div id="modal-contents" class="w-full max-w-screen-lg rounded bg-white bg-opacity-100 p-5 shadow">
    <div class="flex flex-col-reverse">
        <button
            _="on click hide #modal-{{ job.maestro_id }} with visibility then set innerHTML of #modal-{{ job.maestro_id }} to ' '"
            type="button"
            class="bg-ellablue-darkest hover:bg-ellablue-darker mb-3 w-24 self-end rounded-md px-2 py-1 text-sm text-white"
            title="Close modal"
        >
            Close
        </button>
    </div>

    <div class="block w-full overflow-hidden text-sm">
        <!-- tab labels -->
        <input
            class="peer/pending absolute opacity-0"
            name="tabs-{{ job.maestro_id }}"
            type="radio"
            id="pending-{{ job.maestro_id }}"
            checked
        />
        <label
            class="peer-checked/pending:border-ellablue-darkest peer-checked/pending:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="pending-{{ job.maestro_id }}"
            >Missing inputs</label
        >
        <input
            class="peer/created absolute opacity-0"
            name="tabs-{{ job.maestro_id }}"
            type="radio"
            id="created-{{ job.maestro_id }}"
        />
        <label
            class="peer-checked/created:border-ellablue-darkest peer-checked/created:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="created-{{ job.maestro_id }}"
            >Existing inputs</label
        >
        <input
            class="peer/action absolute opacity-0"
            name="tabs-{{ job.maestro_id }}"
            type="radio"
            id="action-{{ job.maestro_id }}"
        />
        <label
            class="peer-checked/action:border-ellablue-darkest peer-checked/action:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="action-{{ job.maestro_id }}"
            >Action</label
        >
        <!-- tab content missing (pending) inputs -->
        <div class="hidden peer-checked/pending:block">
            <div class="mt-8 px-4">
                <div class="px-2 text-lg font-semibold">Missing inputs</div>
                <div class="mt-5 h-[36rem] overflow-auto rounded px-2">
                    <div class="mt-0 grid min-w-full grid-flow-row grid-cols-[auto,1fr] gap-y-1">
                        {% if job.formatted_pending %}
                            <div
                                class="mb-1 border-b-2 border-b-gray-300 py-2 text-left font-semibold"
                            >
                                Type
                            </div>
                            <div
                                class="mb-1 border-b-2 border-b-gray-300 py-2 text-left font-semibold"
                            >
                                Identifier
                            </div>
                            {% for input in job.formatted_pending %}
                                <div
                                    class="copyText mb-2 mr-6 mt-0 cursor-pointer"
                                    title="Click to copy"
                                    _="on click call toClipboard(`{{ input.type|e }}`)"
                                >
                                    {{ input.type }}
                                </div>
                                <div>
                                    {% for key, value in input.identifier.items() %}
                                        <span>{{ key }}: </span>
                                        <span
                                            class="copyText cursor-pointer"
                                            title="Click to copy"
                                            _="on click call toClipboard(`{{ value|e }}`)"
                                            >{{ value }}</span
                                        >
                                    {% endfor %}
                                </div>
                            {% endfor %}
                        {% else %}
                            <div class="inline-flex items-center text-gray-400">
                                <img
                                    src="/static/information_sign_gray.svg"
                                    alt="Information sign"
                                    class="m-3 h-7 w-7"
                                />
                                <div>No missing input artefacts</div>
                            </div>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
        <!-- tab content existing (created) inputs -->
        <div class="hidden peer-checked/created:block">
            <div class="mt-8 px-4">
                <div class="px-2 text-lg font-semibold">Existing inputs</div>
                <div class="mt-5 h-[36rem] overflow-auto rounded px-2">
                    {% for input in job.created %}
                        <div class="mb-1 border-b-2 border-b-gray-300 py-2 text-left font-semibold">
                            {{ input.type }}
                        </div>
                        {{ input.html | safe }}
                    {% else %}
                        <div class="inline-flex items-center text-gray-400">
                            <img
                                src="/static/information_sign_gray.svg"
                                alt="Information sign"
                                class="m-3 h-7 w-7"
                            />
                            <div>No existing input artefacts</div>
                        </div>
                    {% endfor %}
                </div>
            </div>
        </div>
        <!-- tab content for actions -->
        <div class="mt-8 hidden px-4 peer-checked/action:block">
            <div class="px-2 text-lg font-semibold">Action: Steps or artefacts</div>
            <div class="mt-5 h-[36rem] overflow-auto rounded px-2">
                <!-- Warning message -->
                <div
                    class="bg-ellared-light border-ellared-darker mb-5 inline-flex w-full items-center justify-center rounded-lg border py-1"
                >
                    <img src="/static/warning_sign.svg" alt="Warning sign" class="m-3 h-6 w-6" />
                    <div class="text-gray-500">
                        Use actions below with caution, as they cannot be undone!
                    </div>
                </div>
                <!-- Pane for invalidation actions. -->
                <!-- Note: As there are no outputs, no invalidation is possible for pending jobs - only included for UI consistency -->
                <div class="float-left w-1/2 pr-4">
                    <!-- Invalidate workflow step -->
                    <div class="mb-2 font-medium">Invalidate all output from step</div>
                    <div class="mb-2 text-gray-500">
                        This will invalidate <span class="italic">all</span> output artefacts from
                        this step. Propagation will also affect all downstream steps.
                    </div>
                    <!-- Invalidate button with dialogue. Note: Always inactive for pending jobs -->
                    <div class="mx-2 my-3">
                        {{ macros.invalidate(job.invalidated_at, job.status, job.maestro_id, "workflow_step", "propagate") }}
                    </div>
                    <!-- Invalidated artefacts. Note: Always inactive for pending jobs - skipping logic from workflow_step_details.html  -->
                    <div class="mb-2 mt-8 font-medium">Invalidate individual artefacts</div>
                    <div class="mb-2 text-gray-500">
                        Invalidate individual output artefacts here. Propagation will also affect
                        all downstream steps using the artefact.
                    </div>
                    <div id="invalidate-artefact-container">
                        <div
                            class="ml-2 mt-1 inline-flex items-center font-sans text-sm text-gray-400"
                        >
                            <img
                                src="/static/information_sign_gray.svg"
                                alt="Information sign"
                                class="mr-3 h-7 w-7"
                            />
                            <div>No output artefacts to invalidate</div>
                        </div>
                    </div>
                </div>
                <!-- Pane for Reorder/Resume/Abort actions -->
                <div class="float-right w-1/2 pl-4">
                    <!--  Reorder workflow step  -->
                    <div class="mb-2 font-medium">
                        Reorder invalidated, cancelled or failed step
                    </div>
                    <div class="text-gray-500">
                        Reordering this step will attempt to create new output artefacts. Note that
                        this will also affect downstream steps.
                    </div>
                    <!--
                        Reorder button with dialogue.
                        Note: Invalidation status is always "None" for steps that use job_details: pending, cancelled or failed steps that don't have a workflow_step_maestro_id.
                    -->
                    <div class="mx-2 my-3" id="reorder-container">
                        {{ macros.reorder(None, job.maestro_id, "workflow_step", job.status) }}
                    </div>
                    <!-- Show Abort only for pending jobs (running/queued/halted handled in workflow_step_details) -->
                    {% if job.status | string == 'JobStatus.PENDING' %}
                        <!-- Abort step -->
                        <div class="mb-2 mt-8 font-medium">Abort step</div>
                        <div class="text-gray-500">
                            Aborting this step will stop the workflow and invalidate all downstream
                            steps.
                        </div>
                        <!-- Abort button with dialogue -->
                        <div class="mx-2 my-3" id="abort-container">
                            {{ macros.abort(job.maestro_id) }}
                        </div>
                    {% endif %}
                </div>
            </div>
        </div>
        <!-- footer -->
        <div id="footer" class="text-center">
            <!-- Notification for copy to clipboard at bottom of screen -->
            <div
                id="notification"
                class="notification bg-ellapurple border-ellapurple-lighter invisible fixed bottom-0 left-0 z-50 w-full text-ellipsis rounded-sm border-t p-3 text-gray-800 transition"
            ></div>
            <!-- Connected workflow, step type and (if present) job display name -->
            <div
                class="clear-both mx-4 mt-4 flex-col space-x-4 overflow-hidden bg-gray-100 p-1 text-xs text-gray-600 "
            >
                <span class="whitespace-nowrap">
                    <span class="pr-1 font-semibold">Workflow:</span>
                    <span
                        class="copyText cursor-pointer"
                        title="Click to copy"
                        _="on click call toClipboard(`{{ workflow_name }}`)"
                        >{{ workflow_name }}</span
                    >
                </span>
                <span class="whitespace-nowrap">
                    <span class="pr-1 font-semibold">Type:</span>
                    <span
                        class="copyText cursor-pointer"
                        title="Click to copy"
                        _="on click call toClipboard(`{{ job.workflow_step }}`)"
                        >{{ job.workflow_step }}</span
                    >
                </span>
                {% if job.display_name !=None %}
                    <span class="whitespace-nowrap">
                        <span class="pr-1 font-semibold">Name:</span>
                        <span
                            class="copyText cursor-pointer"
                            title="Click to copy"
                            _="on click call toClipboard(`{{ job.display_name }}`)"
                            >{{ job.display_name }}</span
                        >
                    </span>
                {% endif %}
            </div>
        </div>
    </div>
</div>
